Attribute VB_Name = "modDirectX"
Option Explicit

Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Type Skudd
    X As Double
    Y As Double
    Vei As Double
    Enabled As Boolean
    Hva As SkuddType
    BlowupAfter As Integer
    Owner As Integer
End Type

Type Player
    X As Double
    Y As Double
    Z As Double
    BefX As Double
    BefY As Double
    Shoot As Boolean
    Liv As Double
    StandOnBlock As Boolean
    CollWithWater As Boolean
    KeyDown As Integer
    KeyLeft As Integer
    KeyRight As Integer
    KeyUp As Integer
    KeyShoot As Integer
    KeyShift As Integer
    KeyShiftDown As Integer
    Weapon() As SkuddType
    WCount() As Integer
    CurrentWeapon As Integer
    KeyJump As Integer
    LoadingTime As Integer
    Vei As Double
    Jump As Integer
    Husk As Integer
    Visible As Boolean
End Type

Type Bang
    X As Integer
    Y As Integer
    Small As Boolean
    Frame As Integer
    Enabled As Boolean
End Type

Type Text
    X As Integer
    Y As Integer
    Width As Integer
    Text As String
End Type

Type Kasse
    TimeAgain As Integer
    TimeToDestroy As Integer
    What As KasseType
    X As Integer
    Y As Integer
End Type

Type Weapon
    Name As String
    LoadingTime As Integer
    LoseWhenHit As Double
    MovePlayerWhenHit As Integer
    Eksploder As Boolean
    BothLoseLife As Boolean
    SkuddSpeed As Integer
    ArmorCount As Integer
    BlowupAfter As Integer
    SkuddWidth As Integer
    SkuddHeight As Integer
    Blood As Integer
    Spread As Single
    MultiShoot As Long
    SkuddRadius As Long
    NoBlowUp As Boolean
    NoSound As Boolean
End Type

Enum KasseType
    Liv
    Vpen
End Enum

Enum SkuddType
    Pistol
    Granat
    Mashine
    Miner
    Shotgun
    Minigun
    GRnd
    PlasmaRifle
    Lightsaber
End Enum

Public Const HumanSpeed = 2
Public Const Pi = 3.14159265
Public Const Radian = (2 * Pi) / 360

' DirectX
Public DX As New DirectX7
Public dd As DirectDraw7
Public DS As DirectSound
Public DS2 As DirectSound
Public Laser As DirectSoundBuffer
Public Boom As DirectSoundBuffer
Public View As DirectDrawSurface7
Public ViewDesc As DDSURFACEDESC2
Public BuffCaps As DDSCAPS2
Public Buff As DirectDrawSurface7
Public Pic(21) As DirectDrawSurface7
Public PicDesc As DDSURFACEDESC2
Public PicRect(21) As RECT
Public ViewRect As RECT
Public ColorKey As DDCOLORKEY
Public Format As WAVEFORMATEX
Public BoomDesc As DSBUFFERDESC

' Direct Input
Public DI As DirectInput
Public DID As DirectInputDevice
Public DIS As DIKEYBOARDSTATE

' Music
Public cDirectMusic7 As DirectMusic7

' Game
Public Text() As Text, C%, OffWithKey As Boolean, Life%, Credit() As Text
Public Bang() As Bang, Pressed As Boolean, LastKey%, Loading%
Public Player(1) As Player, TempHdc&, Speed%, LR%, InGame As Boolean
Public Skudd() As Skudd, SkuddCount%, Vei%, Max%, Sound As String
Public Kasse As Kasse, Weapon() As Weapon, bSound As Boolean
Public Bokser(19, 13) As Byte, Level$, Lev%

Public Sub IntializeDirectX()

Dim TempPic As StdPicture, PicDC&, A%, Guid$
Dim DEnum As Direct3DEnumDevices, TempColor&

Set dd = Nothing
Set cDirectMusic7 = New DirectMusic7
Set dd = DX.DirectDrawCreate("")

' Loads the MIDI-files
Start.Show
DoEvents

Game.ShowText "Loading music..."

cDirectMusic7.Initialize Game.hWnd, DS2
cDirectMusic7.MIDI_LoadFile App.Path & "\Media\Menu.mid"
cDirectMusic7.MIDI_LoadFile App.Path & "\Media\Game.mid"
cDirectMusic7.MIDI_LoadFile App.Path & "\Media\Lost.mid"
cDirectMusic7.LoopPlay(1) = True
cDirectMusic7.LoopPlay(2) = True
cDirectMusic7.LoopPlay(3) = True
cDirectMusic7.Volume = 100

Player(0).KeyLeft = DIK_LEFT
Player(0).KeyRight = DIK_RIGHT
Player(0).KeyUp = DIK_UP
Player(0).KeyDown = DIK_DOWN
Player(0).KeyJump = DIK_RSHIFT
Player(0).KeyShoot = DIK_RCONTROL
Player(0).KeyShift = DIK_RMENU

Player(1).KeyLeft = DIK_A
Player(1).KeyRight = DIK_D
Player(1).KeyUp = DIK_W
Player(1).KeyDown = DIK_S
Player(1).KeyJump = DIK_LSHIFT
Player(1).KeyShoot = DIK_LCONTROL
Player(1).KeyShift = DIK_LMENU

Set DS = DX.DirectSoundCreate("")
DS.SetCooperativeLevel Game.hWnd, DSSCL_PRIORITY

Set Boom = DS.CreateSoundBufferFromFile(App.Path & "\Media\Boom.wav", BoomDesc, Format)
Set Laser = DS.CreateSoundBufferFromFile(App.Path & "\Media\LASER.wav", BoomDesc, Format)

Set DI = DX.DirectInputCreate()
Set DID = DI.CreateDevice("GUID_SysKeyboard")
DID.SetCommonDataFormat DIFORMAT_KEYBOARD
DID.SetCooperativeLevel Game.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
DID.Acquire

ShowCursor 0

With ViewRect
    .Right = 640
    .Bottom = 480
End With

Game.ShowText "Intializing DirectX"

' Intializing the buffer
dd.SetCooperativeLevel Game.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE
dd.SetDisplayMode ViewRect.Right, ViewRect.Bottom, 16, 0, DDSDM_STANDARDVGAMODE

ViewDesc.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
ViewDesc.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
ViewDesc.lBackBufferCount = 1
Set View = dd.CreateSurface(ViewDesc)

Start.Hide

' Lager bufferen
BuffCaps.lCaps = DDSCAPS_BACKBUFFER
Set Buff = View.GetAttachedSurface(BuffCaps)
Buff.GetSurfaceDesc ViewDesc
Buff.SetFont Game.Font
Buff.SetForeColor Game.ForeColor

PicRect(0).Right = 32
PicRect(0).Bottom = 32
PicRect(1).Right = 6401
PicRect(1).Bottom = 182
PicRect(2).Right = ViewRect.Right
PicRect(2).Bottom = ViewRect.Bottom
PicRect(3).Right = 9
PicRect(3).Bottom = 18
PicRect(4).Right = 1300
PicRect(4).Bottom = 100
PicRect(5).Right = 22
PicRect(5).Bottom = 17
PicRect(6).Right = 37
PicRect(6).Bottom = 24
PicRect(7).Right = 640
PicRect(7).Bottom = 45
PicRect(8).Right = 18
PicRect(8).Bottom = 19

For A = 9 To 21
    PicRect(A).Right = 32
    PicRect(A).Bottom = 32
Next

PicDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
PicDesc.ddsCaps.lCaps = DDSCAPS_VIDEOMEMORY
PicDesc.lWidth = PicRect(0).Right
PicDesc.lHeight = PicRect(0).Bottom
Set Pic(0) = dd.CreateSurfaceFromFile(App.Path & "\Media\Grass.bmp", PicDesc)

PicDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
PicDesc.lWidth = PicRect(1).Right
PicDesc.lHeight = PicRect(1).Bottom
Set Pic(1) = dd.CreateSurface(PicDesc)

PicDesc.lWidth = PicRect(2).Right
PicDesc.lHeight = PicRect(2).Bottom
Set Pic(2) = dd.CreateSurface(PicDesc)

PicDesc.lWidth = PicRect(4).Right
PicDesc.lHeight = PicRect(4).Bottom
Set Pic(4) = dd.CreateSurface(PicDesc)

PicDesc.lWidth = PicRect(5).Right
PicDesc.lHeight = PicRect(5).Bottom
Set Pic(5) = dd.CreateSurfaceFromFile(App.Path & "\Media\Live.bmp", PicDesc)

PicDesc.lWidth = PicRect(6).Right
PicDesc.lHeight = PicRect(6).Bottom
Set Pic(6) = dd.CreateSurfaceFromFile(App.Path & "\Media\Kasse.bmp", PicDesc)

PicDesc.ddsCaps.lCaps = DDSCAPS_VIDEOMEMORY
PicDesc.lWidth = PicRect(7).Right
PicDesc.lHeight = PicRect(7).Bottom
Set Pic(7) = dd.CreateSurface(PicDesc)

PicDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
PicDesc.lWidth = PicRect(8).Right
PicDesc.lHeight = PicRect(8).Bottom
Set Pic(8) = dd.CreateSurfaceFromFile(App.Path & "\Media\Miner.bmp", PicDesc)

PicDesc.lWidth = PicRect(9).Right
PicDesc.lHeight = PicRect(9).Bottom
Set Pic(9) = dd.CreateSurfaceFromFile(App.Path & "\Media\bunker1.bmp", PicDesc)

PicDesc.lWidth = PicRect(10).Right
PicDesc.lHeight = PicRect(10).Bottom
Set Pic(10) = dd.CreateSurfaceFromFile(App.Path & "\Media\bunker2.bmp", PicDesc)

PicDesc.lWidth = PicRect(11).Right
PicDesc.lHeight = PicRect(11).Bottom
Set Pic(11) = dd.CreateSurfaceFromFile(App.Path & "\Media\desert.bmp", PicDesc)

PicDesc.lWidth = PicRect(12).Right
PicDesc.lHeight = PicRect(12).Bottom
Set Pic(12) = dd.CreateSurfaceFromFile(App.Path & "\Media\d_rock.bmp", PicDesc)

PicDesc.lWidth = PicRect(13).Right
PicDesc.lHeight = PicRect(13).Bottom

Set Pic(13) = dd.CreateSurfaceFromFile(App.Path & "\Media\g.bmp", PicDesc)
Set Pic(14) = dd.CreateSurfaceFromFile(App.Path & "\Media\water_corner.bmp", PicDesc)
Set Pic(15) = dd.CreateSurfaceFromFile(App.Path & "\Media\water_side.bmp", PicDesc)
Set Pic(16) = dd.CreateSurfaceFromFile(App.Path & "\Media\water_middle.bmp", PicDesc)
Set Pic(17) = dd.CreateSurfaceFromFile(App.Path & "\Media\g_stripes.bmp", PicDesc)
Set Pic(18) = dd.CreateSurfaceFromFile(App.Path & "\Media\g_stripes2.bmp", PicDesc)
Set Pic(19) = dd.CreateSurfaceFromFile(App.Path & "\Media\deepwater_side.bmp", PicDesc)
Set Pic(20) = dd.CreateSurfaceFromFile(App.Path & "\Media\deepwater.bmp", PicDesc)
Set Pic(21) = dd.CreateSurfaceFromFile(App.Path & "\Media\deepwater_corner.bmp", PicDesc)

TempHdc = CreateCompatibleDC(0)

Set TempPic = LoadPicture(App.Path & "\Media\Menu.gif")
SelectObject TempHdc, TempPic.Handle
TempColor = GetPixel(TempHdc, 0, 0)
PicDC = Pic(7).GetDC
BitBlt PicDC, 0, 0, PicRect(7).Right, PicRect(7).Bottom, TempHdc, 0, 0, vbSrcCopy
Pic(7).ReleaseDC PicDC
Set TempPic = Nothing

Set TempPic = LoadPicture(App.Path & "\Media\Boom.gif")
SelectObject TempHdc, TempPic.Handle
TempColor = GetPixel(TempHdc, 0, 0)
PicDC = Pic(1).GetDC
BitBlt PicDC, 0, 0, PicRect(1).Right, PicRect(1).Bottom, TempHdc, 0, 0, vbSrcCopy
Pic(1).ReleaseDC PicDC
Set TempPic = Nothing

ColorKey.low = TempColor
ColorKey.high = TempColor
Pic(1).SetColorKey DDCKEY_SRCBLT, ColorKey

Set TempPic = LoadPicture(App.Path & "\Media\Explosion.gif")

SelectObject TempHdc, TempPic.Handle
TempColor = GetPixel(TempHdc, 0, 0)
PicDC = Pic(4).GetDC
BitBlt PicDC, 0, 0, PicRect(4).Right, PicRect(4).Bottom, TempHdc, 0, 0, vbSrcCopy
Pic(4).ReleaseDC PicDC
DeleteDC TempHdc

Set TempPic = Nothing

PicDesc.lWidth = PicRect(3).Right
PicDesc.lHeight = PicRect(3).Bottom
Set Pic(3) = dd.CreateSurfaceFromFile(App.Path & "\Media\Gra.bmp", PicDesc)

Pic(2).setDrawStyle 5
Pic(2).SetFillColor vbRed

ColorKey.low = TempColor
ColorKey.high = TempColor
Pic(4).SetColorKey DDCKEY_SRCBLT, ColorKey

ColorKey.low = vbWhite
ColorKey.high = vbWhite
Pic(3).SetColorKey DDCKEY_SRCBLT, ColorKey

ColorKey.low = 0
ColorKey.high = 0
Pic(8).SetColorKey DDCKEY_SRCBLT, ColorKey

End Sub

Public Sub UnloadDirectX()

Dim A&

dd.RestoreDisplayMode
dd.SetCooperativeLevel Start.hWnd, DDSCL_NORMAL

For A = 0 To 10
    Set Pic(A) = Nothing
Next

Set DX = Nothing
Set dd = Nothing
Set DS = Nothing
Set DS2 = Nothing
Set View = Nothing
Set Buff = Nothing
Set Laser = Nothing
Set Buff = Nothing

End Sub



